// Lokales Radar zeigt Flugobjekte, Tanks, Fahrzeuge und wahlweise Personen   [Vienna, 01.03.2011]
// Der Radarbereich wird durch einen blinkenden Ring angezeigt.
//
// Als feindlich erkannte Objekte sind rot, eigene Seite grn, alles Andere blau.
//   Bei Flugobjekten wird auch die Hhe angezeigt.
//
// Aufruf: [Radarobjekt, Radarradius, true/false Personen anzeigen] execVM "RadarAll.sqf"
// Beispiel fr Auslser: temp = [player,2000, true] execVM "RadarAll2.sqf"

private ["_radar","_radius","_marker","_kind","_mID","_mrID","_mf","_mg","_mt","_mx"];

_radar  = _this select 0;
_radius = _this select 1;

// _kind = anzuzeigende Objektgruppen
_kind = ["Air","Tank","Car"];
//auch Personen-Objekte anzeigen?
if (_this select 2) then {_kind = _kind + ["Man"]};

// Beim Ersten ffnen der Karte eine Information anzeigen
waitUntil {visibleMap};
titleText ["Einmalige Information zu den Farben des 'Objektradars':\n\nRot = als feindlich erkannt\n\nGruen = eigene Seite\n\nGelb = eigene Position\n\nBlau = alles Andere\n\nDer 'Radarbereich' wird durch einen\norange blinkenden Ring angezeigt. ","plain",2];

while {alive _radar} do
  {
    //warten bis Map offen?
    waitUntil {visibleMap};
    //Marker fr Radarreichweite erstellen
    _mrID = createMarkerLocal ["AllRadar4711", position _radar];
    _mrID setMarkerShapeLocal "ELLIPSE";
    _mrID setMarkerBrushLocal "BORDER";
    _mrID setMarkerSizeLocal  [_radius,_radius];
    _mrID setMarkerColorLocal "ColorOrange";
    //Durchlauf aller Objekte im Radarbereich 
    _marker = []; // fr die Speicherung der Unit-Marker IDs
    {
      if (alive _x) then
        {
          // _mf = Markerfarbe: blau=unbekannt, grn=freundlich, rot=feindlich
          if (player countEnemy[_x]==1) then
            {
             _mf="ColorRed"
            }
          else
            {
              if (side _x == playerSide) then
                {
                  _mf="ColorGreen"
                }
              else
                {
                  _mf="ColorBlue"
                }
            };
          // _mt = Markertype
          // _mg = Markergre
          // _mx = Markertext
          if (_x isKindOf "Air") then   //Flug-Objekt
            {
              //Flughhe
              if (position _x select 2 > 3) then
                {
                  _mx = " >>"+str(floor(position _x select 2))+"m^<<"
                }
              else
                {
                  _mx = " >>am Boden<<" 
                };
              _mt = "Air";
              _mg = [0.9,0.9];
              _mx = str typeOf _x + _mx
            };
          if (_x isKindOf "Tank") then  //Tank-Objekt 
            {
              _mt = "Tank";
              _mg = [0.9,0.9];
              _mx = str typeOf _x
            };
          if (_x isKindOf "Car") then   //Car-Objekt
            {
              _mt = "Car";
              _mg = [0.8,0.5];
              _mx = str typeOf _x
            };
          if (_x isKindOf "Man") then   //Man-Objekt
            {
              _mt = "Vehicle";
              _mg = [2,2];
              _mx = ""; 
              if (_x == player) then
                {
                  _mx = "<-" + (name player);
                  _mf = "ColorYellow"
                }
            }; 
         //Marker Erstellen
          _mID = createMarkerLocal [str _x, position _x];
          _mID setMarkerTypeLocal  _mt;
          _mID setMarkerTextLocal  _mx;
          _mID setMarkerColorLocal _mf;
          _mID setMarkerSizeLocal  _mg;
          //Marker ID in Array speichern
          _marker = _marker + [_mID]
        }
    } forEach nearestObjects [_radar,_kind,_radius];
    sleep 0.3;
    //Reichweitenmarker lschen
    deleteMarkerLocal _mrID; 
    sleep 1.7;
    //alle Objektmarker lschen
    {deleteMarkerLocal _x} foreach _marker 
   }
